(function () {
    /****************
     * Maps
     ****************/
    addMarkers = function () {
        var markers = [
            {
                identifier: "newphoria",
                coordinate: {
                    latitude: 35.6552640,
                    longitude: 139.7068899,
                },
                title: "Newphoria Corporation"
            }
        ];
        document.getElementById("dumpAreaMap").value = "addMarkers markers";
        applican.maps.addMarkers(markers, function (addedMarkers) {
            // 追加完了
            var dump = "addMarkers\n";
            for (var i in addedMarkers) {
                var marker = addedMarkers[i];
                dump += JSON.stringify(marker);
                // console.log(JSON.stringify(marker));
            }
            document.getElementById("dumpAreaMap").value = dump;
        }, function (error) {
            // 追加失敗
            document.getElementById("dumpAreaMap").value = JSON.stringify(error);
        });
    };

    getCameraPosition = function () {
        applican.maps.getCameraPosition(function (cameraPosition) {
            document.getElementById("dumpAreaMap").value = JSON.stringify(cameraPosition);
        }, function (error) {
            document.getElementById("dumpAreaMap").value = JSON.stringify(error);
        });
        document.getElementById("dumpAreaMap").value = "getCameraPosition";
    };

    getMarkers = function () {
        applican.maps.getMarkers(function (markers) {
            // 取得成功
            var dump = "getMarkers\n";
            for (var i in markers) {
                var marker = markers[i];
                // console.log(JSON.stringify(marker));
                dump += JSON.stringify(marker);
            }
            document.getElementById("dumpAreaMap").value = dump;
        }, function (error) {
            // 取得失敗
            document.getElementById("dumpAreaMap").value = JSON.stringify(error);
        });
        document.getElementById("dumpAreaMap").value = "getMarkers";
    };

    getRegion = function () {
        applican.maps.getRegion(function (region) {
            //
            document.getElementById("dumpAreaMap").value = JSON.stringify(region);
        }, function (error) {
            //
            document.getElementById("dumpAreaMap").value = JSON.stringify(error);
        });
    };

    hide = function () {
        applican.maps.hide(function () {
            //
            document.getElementById("dumpAreaMap").value = "success";
        }, function (error) {
            //
            document.getElementById("dumpAreaMap").value = JSON.stringify(error);
        });
    };

    removeAllMarkers = function () {
        applican.maps.removeAllMarkers(function (removedMarkers) {
            // 削除完了
            var dump = "removeAllMarkers\n";
            for (var i in removedMarkers) {
                var marker = removedMarkers[i];
                // console.log(JSON.stringify(marker));
                dump += JSON.stringify(marker);
            }
            document.getElementById("dumpAreaMap").value = dump;
        }, function (error) {
            // 削除失敗
            document.getElementById("dumpAreaMap").value = JSON.stringify(error);
        });
    };

    removeMarkers = function () {
        var identifiers = ["newphoria"];

        applican.maps.removeMarkers(identifiers, function (removedMarkers) {
            // 削除完了
            var dump = "removeMarkers\n";
            for (var i in removedMarkers) {
                var marker = removedMarkers[i];
                // console.log(JSON.stringify(marker));
                dump += JSON.stringify(marker);
            }
            document.getElementById("dumpAreaMap").value = dump;
        }, function (error) {
            // 削除失敗
            document.getElementById("dumpAreaMap").value = JSON.stringify(error);
        });
    };

    setCameraPosition = function () {
        var position = {
            center: {
                latitude: 0,
                longitude: 0,
            },
        };

        applican.maps.setCameraPosition(position, 1000, function (newPosition) {
            // NOTE: nullが返ってくる
            document.getElementById("dumpAreaMap").value = JSON.stringify(newPosition);
        }, function (error) {
            // 失敗
            document.getElementById("dumpAreaMap").value = JSON.stringify(error);
        });
    };

    show = function () {
        var options = {
            type: applican.maps.MAP_TYPE_STANDARD,
            style: '[ { "featureType": "all", "stylers": [ { "color": "#C0C0C0" } ] },{ "featureType": "road.arterial", "elementType": "geometry", "stylers": [ { "color": "#CCFFFF" } ] },{ "featureType": "landscape", "elementType": "labels", "stylers": [ { "visibility": "off" } ] } ]',
            position: {
                x: 1,
                y: 1,
                width: 500,
                height: 100,
            },
            compass: true,
            buildings: false,
            zoomControls: false,
            scale: true,
            traffic: false,
            cameraPosition: {
                center: {
                    latitude: 35.6552640,
                    longitude: 139.7068899,
                },
            },
            userLocation: {
                updateInterval: 3000,
                minDistance: 100,
            },
            onCameraPositionWillChange: function (currentPosition) {
                // カメラ移動開始
                console.log(currentPosition);
            },
            onCameraPositionChanged: function (newPosition) {
                // カメラ移動完了
                console.log(newPosition);
            },
            onUserLocationChanged: function (userLocation) {
                // 現在位置が変わった
                console.log(userLocation);
            },
            onMarkerClicked: function (identifier, coordinate) {
                // マーカーがクリックされた
                console.log(identifier);
            },
        };

        applican.maps.show(options, function () {
            // 地図表示完了
            document.getElementById("dumpAreaMap").value = "show map finished.";
        }, function (error) {
            // エラー
            document.getElementById("dumpAreaMap").value = error.code;
        });
    };

    move = function () {
        var options = {
            position: {
                x: 0,
                y: 0,
                width: 200,
                height: 100,
            },
        };

        applican.maps.show(options, 1000, function () {
            document.getElementById("dumpAreaMap").value = "move";
        }, function (error) {
            document.getElementById("dumpAreaMap").value = JSON.stringify(error);
        });
    };

    emptyOptions = function () {
        var options = {
        };

        applican.maps.show(options, function () {
            document.getElementById("dumpAreaMap").value = "success";
        }, function (error) {
            document.getElementById("dumpAreaMap").value = JSON.stringify(error);
        });
    };

    getFromLocationName = function () {
        var options = {
            locationName: "東京都渋谷区東1-26-30"
        }
        applican.maps.getFromLocationName(options, function(coordinate) {
            document.getElementById("dumpAreaMap").value = JSON.stringify(coordinate);
        }, function(error) {
            document.getElementById("dumpAreaMap").value = JSON.stringify(error);
        });
    }

    getBounds = function () {
        applican.maps.getBounds(function(success) {
            document.getElementById("dumpAreaMap").value = JSON.stringify(success);
        }, function (error) {
            document.getElementById("dumpAreaMap").value = JSON.stringify(error);
        })
    }

    /********************* イベント登録 *********************/
    document.addEventListener("deviceready", function () {
        document.getElementById("addMarkersButton").addEventListener("touchend", addMarkers, false);
        document.getElementById("getCameraPositionButton").addEventListener("touchend", getCameraPosition, false);
        document.getElementById("getMarkersButton").addEventListener("touchend", getMarkers, false);
        document.getElementById("getRegionButton").addEventListener("touchend", getRegion, false);
        document.getElementById("hideButton").addEventListener("touchend", hide, false);
        document.getElementById("removeAllMarkersButton").addEventListener("touchend", removeAllMarkers, false);
        document.getElementById("removeMarkersButton").addEventListener("touchend", removeMarkers, false);
        document.getElementById("setCameraPositionButton").addEventListener("touchend", setCameraPosition, false);
        document.getElementById("showButton").addEventListener("touchend", show, false);
        document.getElementById("moveButton").addEventListener("touchend", move, false);
        document.getElementById("get_from_location_name_button").addEventListener("touchend", getFromLocationName, false);
        document.getElementById("getBounds").addEventListener("touchend", getBounds, false);
    }, false);
})();
